package blusunrize.immersiveengineering.common.items;

import blusunrize.immersiveengineering.api.Lib;
import blusunrize.immersiveengineering.client.models.IOBJModelCallback;
import blusunrize.immersiveengineering.common.gui.IESlot;
import blusunrize.immersiveengineering.common.util.EnergyHelper.IIEEnergyItem;
import blusunrize.immersiveengineering.common.util.IEDamageSources;
import blusunrize.immersiveengineering.common.util.IEDamageSources.TeslaDamageSource;
import blusunrize.immersiveengineering.common.util.IEPotions;
import blusunrize.immersiveengineering.common.util.IESounds;
import blusunrize.immersiveengineering.common.util.Utils;
import blusunrize.immersiveengineering.common.util.chickenbones.Matrix4;
import net.minecraft.block.BlockDispenser;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms.TransformType;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.resources.I18n;
import net.minecraft.client.util.ITooltipFlag;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.Slot;
import net.minecraft.item.EnumAction;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.ItemStack;
import net.minecraft.potion.PotionEffect;
import net.minecraft.util.*;
import net.minecraft.util.math.Vec3d;
import net.minecraft.world.World;
import net.minecraftforge.event.entity.living.LivingAttackEvent;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nullable;
import java.util.List;

public class ItemIEShield extends ItemUpgradeableTool implements IIEEnergyItem, IOBJModelCallback<ItemStack>
{
	public ItemIEShield()
	{
		super("shield", 1, "SHIELD");
		this.func_77656_e(1024);
		BlockDispenser.field_149943_a.func_82595_a(this, ItemArmor.field_96605_cw);
	}

	@Override
	@SideOnly(Side.CLIENT)
	public void func_77624_a(ItemStack stack, @Nullable World world, List<String> list, ITooltipFlag flag)
	{
		if(this.getMaxEnergyStored(stack)>0)
		{
			String stored = this.getEnergyStored(stack)+"/"+this.getMaxEnergyStored(stack);
			list.add(I18n.func_135052_a(Lib.DESC+"info.energyStored", stored));
		}
	}

	@Override
	public void func_77663_a(ItemStack stack, World world, Entity ent, int slot, boolean inHand)
	{
		if(!world.field_72995_K && (!inHand || !(ent instanceof EntityLivingBase) || ((EntityLivingBase)ent).func_184607_cu()!=stack))//Don't recharge if in use, to avoid flickering
		{
			if(getUpgrades(stack).func_74764_b("flash_cooldown") && this.extractEnergy(stack, 20, true)==20)
			{
				this.extractEnergy(stack, 20, false);
				int cooldown = getUpgrades(stack).func_74762_e("flash_cooldown");
				if(--cooldown<=0)
					getUpgrades(stack).func_82580_o("flash_cooldown");
				else
					getUpgrades(stack).func_74768_a("flash_cooldown", cooldown);
			}
			if(getUpgrades(stack).func_74764_b("shock_cooldown") && this.extractEnergy(stack, 20, true)==20)
			{
				this.extractEnergy(stack, 20, false);
				int cooldown = getUpgrades(stack).func_74762_e("shock_cooldown");
				if(--cooldown<=0)
					getUpgrades(stack).func_82580_o("shock_cooldown");
				else
					getUpgrades(stack).func_74768_a("shock_cooldown", cooldown);
			}
		}
	}

	public void damageShield(ItemStack stack, EntityPlayer player, int damage, DamageSource source, float amount, LivingAttackEvent event)
	{
		stack.func_77972_a(damage, player);
		if(getUpgrades(stack).func_74767_n("flash") && getUpgrades(stack).func_74762_e("flash_cooldown")<=0)
		{
			Vec3d look = player.func_70040_Z();
			//Offsets Player position by look backwards, then truncates cone at 1
			List<EntityLivingBase> targets = Utils.getTargetsInCone(player.func_130014_f_(), player.func_174791_d().func_178788_d(look), player.func_70040_Z().func_186678_a(9), 1.57079f, .5f);
			for(EntityLivingBase t : targets)
				if(!player.equals(t))
					t.func_70690_d(new PotionEffect(IEPotions.flashed,100,1));
			getUpgrades(stack).func_74768_a("flash_cooldown",40);
		}
		if(getUpgrades(stack).func_74767_n("shock") && getUpgrades(stack).func_74762_e("shock_cooldown")<=0)
		{
			boolean b = false;
			if(event.getSource().func_76352_a() && event.getSource().func_76364_f()!=null)
			{
				Entity projectile = event.getSource().func_76364_f();
				projectile.func_70106_y();
				event.setCanceled(true);
				b = true;
			}
			if(event.getSource().func_76346_g()!=null && event.getSource().func_76346_g() instanceof EntityLivingBase && event.getSource().func_76346_g().func_70068_e(player)<4)
			{
				TeslaDamageSource dmgsrc = IEDamageSources.causeTeslaDamage(1, true);
				dmgsrc.apply(event.getSource().func_76346_g());
				b = true;
			}
			if(b)
			{
				getUpgrades(stack).func_74768_a("shock_cooldown",40);
				player.field_70170_p.func_184148_a(null, player.field_70165_t, player.field_70163_u, player.field_70161_v, IESounds.spark, SoundCategory.BLOCKS, 2.5F, 0.5F+Utils.RAND.nextFloat());
			}
		}
	}

	@Override
	public boolean func_82789_a(ItemStack stack, ItemStack material)
	{
		return Utils.compareToOreName(material, "ingotSteel");
	}

	@Override
	public int getMaxEnergyStored(ItemStack container)
	{
		return (getUpgrades(container).func_74767_n("flash")||getUpgrades(container).func_74767_n("shock"))?1600:0;
	}

	@Override
	public int func_77626_a(ItemStack stack)
	{
		return 72000;
	}
	@Override
	public ActionResult<ItemStack> func_77659_a(World worldIn, EntityPlayer playerIn, EnumHand handIn)
	{
		ItemStack itemstack = playerIn.func_184586_b(handIn);
		playerIn.func_184598_c(handIn);
		return new ActionResult(EnumActionResult.SUCCESS, itemstack);
	}
	@Override
	public EnumAction func_77661_b(ItemStack stack)
	{
		return EnumAction.BLOCK;
	}

	@Override
	public TextureAtlasSprite getTextureReplacement(ItemStack object, String material)
	{
		return null;
	}
	@Override
	public boolean shouldRenderGroup(ItemStack object, String group)
	{
		if("flash".equals(group))
			return getUpgrades(object).func_74767_n("flash");
		else if("shock".equals(group))
			return getUpgrades(object).func_74767_n("shock");
		return true;
	}
	@Override
	public Matrix4 handlePerspective(ItemStack Object, TransformType cameraTransformType, Matrix4 perspective, EntityLivingBase entity)
	{
		if(entity!=null && entity.func_184587_cr())
			if((entity.func_184600_cs()==EnumHand.MAIN_HAND) == (entity.func_184591_cq()==EnumHandSide.RIGHT))
			{
				if(cameraTransformType==TransformType.FIRST_PERSON_RIGHT_HAND)
					perspective.rotate(-.15, 1, 0, 0).translate(-.25, .5, -.4375);
				else if(cameraTransformType==TransformType.THIRD_PERSON_RIGHT_HAND)
					perspective.rotate(0.52359, 1, 0, 0).rotate(0.78539, 0, 1, 0).translate(.40625, -.125, -.125);
			}
			else
			{
				if(cameraTransformType==TransformType.FIRST_PERSON_LEFT_HAND)
					perspective.rotate(.15, 1, 0, 0).translate(.25, .375, .4375);
				else if(cameraTransformType==TransformType.THIRD_PERSON_LEFT_HAND)
					perspective.rotate(-0.52359, 1, 0, 0).rotate(0.78539, 0, 1, 0).translate(.1875, .3125, .5625);
			}
		return perspective;
	}

	@Override
	public boolean canModify(ItemStack stack)
	{
		return true;
	}
	@Override
	public Slot[] getWorkbenchSlots(Container container, ItemStack stack, IInventory invItem)
	{
		return new Slot[]
				{
						new IESlot.Upgrades(container, invItem,0, 80,32, "SHIELD", stack, true),
						new IESlot.Upgrades(container, invItem,1,100,32, "SHIELD", stack, true)
//						new IESlot.Upgrades(container, invItem,2,100,32, "SHIELD", stack, true)
				};

	}
	@Override
	public int getInternalSlots(ItemStack stack)
	{
		return 2;
	}
}
